#include <iostream>
#include <cmath>
#include <algorithm>
#include <iomanip>

using namespace std;

typedef long double real;
typedef long long TT;

#define SQR(x) ((x)*(x))

real dist(int xa, int ya, int xb, int yb)
{
   return sqrt(real(SQR(xb-xa) + SQR(yb-ya)));
}

int vect(int xa, int ya, int xb, int yb, int x, int y)
{
   return (x-xa)*(yb-ya) - (y-ya)*(xb-xa);
}

int scal(int xa, int ya, int x, int y, int xb, int yb)
{
   int x1 = xa - x, y1 = ya - y;
   int x2 = xb - x, y2 = yb - y;
   return x1*x2 + y1*y2;
}

int inter(int xa, int ya, int xb, int yb, int xc, int yc, int xd, int yd)
{
   TT v1 = vect(xa, ya, xb, yb, xc, yc);
   TT v2 = vect(xa, ya, xb, yb, xd, yd);
   TT v3 = vect(xc, yc, xd, yd, xa, ya);
   TT v4 = vect(xc, yc, xd, yd, xb, yb);
   return v1*v2 < 0 && v3*v4 < 0;
}

real seg_dist(int x, int y, int xa, int ya, int xb, int yb)
{
   if (scal(xa, ya, xb, yb, x, y) <= 0) return dist(xb, yb, x, y);
   if (scal(xb, yb, xa, ya, x, y) <= 0) return dist(xa, ya, x, y);
   real a = yb - ya;
   real b = xa - xb;
   real c = xb*ya - xa*yb;
   real d = sqrt(real(SQR(a) + SQR(b)));
   return fabs((a*x + b*y + c) / d);
}

int main()
{
   freopen("input.txt","rt",stdin); freopen("output.txt","wt",stdout);

   int xa, ya, xb, yb, xp1, yp1, xp2, yp2, cf, cr;
   cin >> xa >> ya >> xb >> yb >> xp1 >> yp1 >> xp2 >> yp2 >> cf >> cr;
   
   real ans = 1E30;
   real t = cf*dist(xa, ya, xb, yb);
   if (inter(xa, ya, xb, yb, xp1, yp1, xp2, yp2)) t += cr;
   ans = min(ans, t);
   
   t = cf * (dist(xa, ya, xp1, yp1) + dist(xb, yb, xp1, yp1));
   ans = min(ans, t);
   t = cf * (dist(xa, ya, xp2, yp2) + dist(xb, yb, xp2, yp2));
   ans = min(ans, t);
   
   t = cf * (seg_dist(xa, ya, xp1, yp1, xp2, yp2) + seg_dist(xb, yb, xp1, yp1, xp2, yp2)) + cr;
   ans = min(ans, t);
   
   cout << fixed << setprecision(3) << ans;

   fclose(stdin); fclose(stdout);
   return 0;   
}
